Subject: RE: [Sip] Question about ABNF for SIP

From: "Rob Phillips" <[email-masked]>
Date: Wed, 3 Jul 2002 06:15:01 -0500

The problem is with the bis-09 definition.  Check the examples in bis-09: from those, it's obvious the rule should be:

	rfc1123-date = wkday "," SP date1 SP time SP "GMT"

- rob

-----Original Message-----
From: Eiji Tomimura [mailto:[email-masked]]
Sent: Wednesday, July 03, 2002 4:10 AM
To: [email-masked]
Subject: [Sip] Question about ABNF for SIP

Dear all,

I have a question regarding ABNF for SIP.

In bis-09, it defines that :
    rfc1123-date = wkday "," date1 SP time SP "GMT"

Though, in RFC2616 "HTTP/1.1", it defines that:
    rfc1123-date = wkday "," SP date1 SP time SP "GMT"

Is it intentional? Or, is it a bug of either side?

Becauses our SIP layer is based on RFC2616 format, it reject Date header
follows the format of bis-09 as syntax error. So I'm wondering which format
should we use.

Thanks in advance.

Regards,
- Eiji Tomimura

-- 
Eiji Tomimura 
Senior Engineer 
Communications Technology Dept., Information Technology R&D Laboratories
Sumitomo Electric Industries, Ltd.
Phone: +81-6-6466-5643  Fax: +81-6-6466-5732  Email: [email-masked]

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: "Rosen, Brian" <[email-masked]>
Date: Wed, 3 Jul 2002 08:00:16 -0400

This problem has been reported before.  We fixed it in the
text of the forthcoming RFC.  The SP is added.

Brian

> Sent: Wednesday, July 03, 2002 5:10 AM
> To: [email-masked]

---

From: David Oliver <[email-masked]>
Date: Fri, 26 Jul 2002 10:01:29 -0500

Eiji,

Although an implementation MUST generate precisely correct (RFC3261) syntax,
it SHOULD accept all syntax it can interpret (i.e. not object to technical
errors where the meaning is still clear), according to the "robustness
principle" defined in section 3.2 of RFC791 [4]:

    an implementation must be conservative in its sending
    behavior, and liberal in its receiving behavior.

This would allow (for example) your implementation to interwork with other
implementations based erroneously on the bis-09 syntax, manually entered
scripts, or with other minor bugs such as misunderstood printf formats.

For example, a more robust acceptance syntax could be:

 rfc1123-date = wkday *SP "," *SP date1 1*SP time 1*SP "GMT"
 date1        = 1*2DIGIT 1*SP month 1*SP 4DIGIT
 time         = 1*2DIGIT ":" *SP 1*2DIGIT ":" *SP 1*2DIGIT

This would accept the following dates:

 Fri, 05 Jul 2002 09:40:01 GMT     -- strict syntax.
 Fri,  5 Jul 2002  9:40: 1 GMT     -- printf with leading zeros as space.
 Fri, 5 Jul 2002 9:40:1 GMT	     -- printf with missing leading zeros.
 Fri ,  05 Jul 2002  09:40:01 GMT  -- hand entered, with bad spacing
                                   -- due to variable sized font.

The acceptance syntax is not significantly more difficult to implement
except in the smallest embedded implementations, and does not cause
ambiguity. Of course, if the extended syntax caused performance or other
problems, it would be the first candidate for removal.

Regards,

David C. Oliver
Principal Engineer
SecureLogix Corp
Email: [email-masked] <mailto:[email-masked]>
Tel:   210.402.9669
Fax:   210.402.6996 

-----Original Message-----
From: Rosen, Brian [mailto:[email-masked]]
Sent: Wednesday, July 03, 2002 7:00 AM
To: 'Eiji Tomimura'; [email-masked]
Subject: RE: [Sip] Question about ABNF for SIP

Brian